from collections import defaultdict, deque

def najmanji_broj_autobusa(N, M, S, T, autobusi):
    graf = defaultdict(list)

    # Kreiranje grafa na osnovu starog plana
    for autobus in autobusi:
        graf[autobus[0]].append(autobus[1])
        graf[autobus[1]].append(autobus[0])

    # Inicijalizacija BFS-a
    posetili = set()
    red = deque([(S, 0)])  # (stanica, broj_autobusa)
    posetili.add(S)

    # BFS pretraga
    while red:
        trenutna_stanica, broj_autobusa = red.popleft()

        # Ako smo stigli do destinacije, vracamo broj autobusa
        if trenutna_stanica == T:
            return broj_autobusa

        # Razmatramo susedne stanice
        for susedna_stanica in graf[trenutna_stanica]:
            if susedna_stanica not in posetili:
                posetili.add(susedna_stanica)
                red.append((susedna_stanica, broj_autobusa + 1))

    return -1  # Ako nije moguce stici od stanice S do stanice T

# Ucitavanje ulaznih podataka
N, M, S, T = map(int, input().split())
autobusi = [tuple(map(int, input().split())) for _ in range(M)]

# Rešavanje zadatka
rezultat = najmanji_broj_autobusa(N, M, S, T, autobusi)

# Ispisivanje rezultata
print(rezultat)