#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    vector<vector<int>> graf_stari;
    vector<vector<int>> graf_novi;
    vector<int> poseceni;
    
    int N, M, S, T;
    cin >> N >> M >> S >> T;

    for (int i = 0; i <= N; i++)
    {
        graf_stari.push_back({});
        graf_novi.push_back({});
        poseceni.push_back(0);
    }
    
    int U, V;
    for (int i = 0; i < M; i++)
    {
        cin >> U >> V;
        graf_stari[U].push_back(V);
        graf_stari[V].push_back(U);
    }

    for (int i = 1; i <= N; i++)
        for (int j = 0; j < (graf_stari[i].size() - 1); j++)
            for (int k = j + 1; k < graf_stari[i].size(); k++)
            {
                    graf_novi[graf_stari[i][j]].push_back(graf_stari[i][k]);
                    graf_novi[graf_stari[i][k]].push_back(graf_stari[i][j]);
            }

    for (int i = 1; i <= N; i++)
    {
        sort(graf_novi[i].begin(), graf_novi[i].end());
        graf_novi[i].erase(unique(graf_novi[i].begin(), graf_novi[i].end()), graf_novi[i].end());
    }

    queue<int> rezervisani;

    int broj_koraka = -1;
    rezervisani.push(S);
    
    int sledeci, nadjen = -1, broj_rezervisanih;
    while (!rezervisani.empty())
    {
        broj_koraka++;
        broj_rezervisanih = rezervisani.size();
        for (int i = 0; i < broj_rezervisanih; i++)
        {
            sledeci = rezervisani.front();
            if (sledeci == T)
            {
                nadjen = broj_koraka;
                break;
            }
            poseceni[sledeci] = 1;
            for (int j = 0; j < graf_novi[sledeci].size(); j++)
                if (poseceni[graf_novi[sledeci][j]] == 0)
                    rezervisani.push(graf_novi[sledeci][j]);
            rezervisani.pop();
        }
        if (nadjen != -1)
            break;
    }

    cout << nadjen;
}