#include <iostream>
#include <vector>
#include <queue>
#include <unordered_set>
#include <tuple>

using namespace std;

class astan {
public:
    astan(int hirosa) {
        brstan = hirosa;
        tsunagi.resize(hirosa);
    }

    void Dodaj(int a, int b) {
        a--; b--;
        if (tsunagi[a].empty()) {
            tsunagi[a] = unordered_set<int>();
        }
        if (tsunagi[b].empty()) {
            tsunagi[b] = unordered_set<int>();
        }

        tsunagi[a].insert(b);
        tsunagi[b].insert(a);
    }

    int Daljina(int a, int b) {
        a--; b--;
        queue<tuple<int, int>> jouhou;

        vector<bool> Btsuu(brstan, false);
        vector<bool> Stsuu(brstan, false);

        jouhou.push(make_tuple(a, 0));

        while (!jouhou.empty()) {
            auto trenutni = jouhou.front();
            jouhou.pop();
            int stanica = get<0>(trenutni);
            int kyori = get<1>(trenutni);

            if (stanica == b) {
                return kyori;
            }
            for (auto s : tsunagi[stanica]) {
                if (Btsuu[s]) { continue; }
                Btsuu[s] = true;
                for (auto rute : tsunagi[s]) {
                    if (Stsuu[rute]) { continue; }
                    Stsuu[rute] = true;
                    jouhou.push(make_tuple(rute, kyori + 1));
                }
            }
        }
        return -1;
    }
private:
    int brstan;
    vector<std::unordered_set<int>> tsunagi;
};

int main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int hirosa, brojVeza, saisho, saigo;
    cin >> hirosa >> brojVeza >> saisho >> saigo;

    astan Basutei(hirosa);

    for (int i = 0; i < brojVeza; i++) {
        int a, b;
        cin >> a >> b;
        Basutei.Dodaj(a, b);
    }

    cout << Basutei.Daljina(saisho, saigo);

}