#include <iostream>
#include <limits>
#include <vector>
#include <stack>

using namespace std;

void ucitaj(vector<int>& niz, int s) {
	for (auto i = 0; i < s; i++) {
		cin >> niz[i];
	}
}

inline bool izmedju(int br,int a,int b) {
	return br >= a && br <= b;
}

inline bool futsuu(int a, int b) {
	if (a == 0 || b == 0) {
		return true;
	}
	return a <= numeric_limits<int>::max() / b && a >= numeric_limits<int>::min() / b;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(NULL);

	int N,S,T;
	cin >> T;

	for (auto j = 0; j < T; j++) {
		cin >> N >> S;
		vector<int> mnozi(N), dodi(N), hidari(N), migi(N);
		ucitaj(mnozi, N);
		ucitaj(dodi, N);
		ucitaj(hidari, N);
		ucitaj(migi, N);

		stack<int> gun;
		gun.push(S);

		for (auto i = 0; i < N; i++) {
			int vel = gun.size();
			for (auto k = 0; k < vel; k++) {
				auto tren = gun.top();
				gun.pop();
				if (futsuu(tren,mnozi[i])) {
					if (izmedju(tren * mnozi[i], hidari[i], migi[i])) {
						gun.push(tren * mnozi[i]);
					}
				}
				if (izmedju(tren + dodi[i], hidari[i], migi[i])) {
					gun.push(tren + dodi[i]);
				}
			}
		}

		if (gun.empty()) {
			cout << "nepoznato";
		}
		else {
			int siska = INT_MIN;
			while (!gun.empty()) {
				siska = max(siska, gun.top());
				gun.pop();
			}
			cout << siska << '\n';
		}
	}
}