#include<iostream>
#include<vector>
#include<queue>

using namespace std;

void BFS(int a, vector<vector<int>>& graf, vector<int>& lista){
    vector<bool> zakazan(graf.size(), false);
    zakazan[a] = true;
    queue<int> red;
    red.push(a);

    while(red.size() != 0){
        int tren = red.front();
        red.pop();
        for(int i = 0; i < graf[tren].size(); i++){
            if(!zakazan[graf[tren][i]]){
                red.push(graf[tren][i]);
                zakazan[graf[tren][i]] = true;
                lista[graf[tren][i]] = lista[tren]+1;
            }
        }
    }
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n, m, s, t;
    cin >> n >> m >> s >> t;
    s--;t--;
    vector<vector<int>> pocetni(n), graf(n);

    for(int i = 0; i < m; i++){
        int a, b;
        cin >> a >> b;
        a--; b--;
        pocetni[a].push_back(b);
        pocetni[b].push_back(a);
    }

    vector<bool> obradjen(n, false);
    for(int i = 0; i < n; i++){
        vector<bool> sledeci(n, false);
        obradjen[i] = true;
        for(int j = 0; j < pocetni[i].size(); j++){
            for(int z = 0; z < pocetni[pocetni[i][j]].size(); z++){
                if(!obradjen[pocetni[pocetni[i][j]][z]] && !sledeci[pocetni[pocetni[i][j]][z]]){
                    graf[i].push_back(pocetni[pocetni[i][j]][z]);
                    graf[pocetni[pocetni[i][j]][z]].push_back(i);
                    sledeci[pocetni[pocetni[i][j]][z]] = true;
                }
            }
        }
    }

    vector<int> a(n);
    a[s] = 0;
    BFS(s, graf, a);
    cout << a[t];
}