#include<iostream>
#include<vector>
#include<queue>

using namespace std;

void BFS(int a, vector<vector<int>>& graf, vector<int>& lista){
    vector<bool> zakazan(graf.size(), false);
    zakazan[a] = true;
    queue<int> red;
    red.push(a);

    while(red.size() != 0){
        int tren = red.front();
        red.pop();
        for(int i = 0; i < graf[tren].size(); i++){
            if(!zakazan[graf[tren][i]]){
                red.push(graf[tren][i]);
                zakazan[graf[tren][i]] = true;
                lista[graf[tren][i]] = lista[tren]+1;
            }
        }
    }
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n, m, s, t;
    cin >> n >> m >> s >> t;
    s--;t--;
    vector<vector<int>> pocetni(n), graf(n);

    for(int i = 0; i < m; i++){
        int a, b;
        cin >> a >> b;
        a--; b--;
        pocetni[a].push_back(b);
        pocetni[b].push_back(a);
    }

    vector<vector<bool>> grana(n, vector<bool> (n, false));
    for(int i = 0; i < n; i++){ //cvor (tj lista koja se gleda)
        for(int j = 0; j < pocetni[i].size(); j++){
            for(int z = j+1; z < pocetni[i].size(); z++){
                if(!grana[pocetni[i][j]][pocetni[i][z]]){
                    graf[pocetni[i][j]].push_back(pocetni[i][z]);
                    graf[pocetni[i][z]].push_back(pocetni[i][j]);

                    grana[pocetni[i][j]][pocetni[i][z]] = true;
                    grana[pocetni[i][z]][pocetni[i][j]] = true;
                }
            }
        }
    }

    vector<int> a(n);
    a[s] = 0;
    BFS(s, graf, a);
    cout << a[t];
}