// #freenumero

#include <iostream>
#include <vector>
#include <queue>
using namespace std;

struct Graph {
    int n;
    vector<vector<int>> v;
    vector<bool> posecenost;
};

void addEdge(Graph &g, int n, int v) {
    g.v[n].push_back(v);
    g.v[v].push_back(n);
}

void novivektor(Graph &g) {
    int n = g.n;
    vector<vector<int>> novi_v(n, vector<int>());

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < g.v[i].size(); j++) {
            for (int k = 0; k < g.v[i].size(); k++) {
                int a = g.v[i][j];
                int b = g.v[i][k];
                if (a != b) {
                    novi_v[a].push_back(b);
                    novi_v[b].push_back(a);
                }
            }
        }
    }

    g.v = novi_v;
}

void init(Graph &g, int n) {
    g.n = n;
    g.v.resize(n);
    g.posecenost.resize(n, false);
}

int BFS(Graph &g, int pocetak, int kraj) {
    g.posecenost[pocetak] = true;
    queue<pair<int, int>> q;
    q.push(make_pair(pocetak, 0));

    while (!q.empty()) {
        int poc = q.front().first;
        int broj = q.front().second;
        q.pop();

        if (poc == kraj)
            return broj;

        for (auto i = g.v[poc].begin(); i != g.v[poc].end(); ++i) {
            int tren = *i;
            if (!g.posecenost[tren]) {
                g.posecenost[tren] = true;
                q.push(make_pair(tren, broj + 1));
            }
        }
    }

    return -1;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n, m, s, t;
    cin >> n >> m >> s >> t;

    Graph g;
    init(g, n);

    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        addEdge(g, x, y);
    }

    s--;
    t--;

    novivektor(g);

    int result = BFS(g, s, t);
    cout << result << endl;

    return 0;
}