#include <bits/stdc++.h>
#define ll long long

using namespace std;

void Solve(ll N, ll S, vector <ll> A, vector <ll> M,
          vector <ll> L, vector <ll> R, vector <ll>& prvih_pola)
{
    ll poc = S;
    for(int bit = 0; bit < (1 << N); bit++)
    {
        ll sad = 0;
        for(int i = 0; i < N; i++)
        {
            if(bit&(1 << i)) S *= M[i];
            else S += A[i];
            if(S < L[i] || S > R[i]) {sad = -2e18; break;}
        }
        if(sad != -2e18) prvih_pola.push_back(S);
        S = poc;
    }
    sort(prvih_pola.begin(), prvih_pola.end());
}

void Intervali(ll pola, ll N, vector <ll> A, vector <ll> M,
    vector <ll> L, vector <ll> R, vector <pair<pair<ll, ll>, vector<pair<char, ll> > > >& svi_intervali)
{
    for(ll i = N - 1; i >= pola; i--)
    {
        if(svi_intervali.size() == 0)
        {
            pair <ll, ll> prvi;
            if(M[i] == 0) prvi = {L[i], R[i]};
            else prvi = {L[i] / M[i], R[i] / M[i]};
            if(prvi.first > prvi.second) swap(prvi.first, prvi.second);

            pair <ll, ll> drugi = {L[i] - A[i], R[i] - A[i]};
            if(drugi.first > drugi.second) swap(drugi.first, drugi.second);

            prvi.first = max(prvi.first, L[i - 1]);
            prvi.second = min(prvi.second, R[i - 1]);

            drugi.first = max(drugi.first, L[i - 1]);
            drugi.second = min(drugi.second, R[i - 1]);

            if(drugi.first <= drugi.second)
            {
                pair <char, ll> par;
                par = {'+', A[i]};
                pair<pair<ll, ll>, vector<pair<char, ll> > > sad = {{drugi.first, drugi.second}, {par}};
                svi_intervali.push_back(sad);
            }

            if(M[i] == 0 && prvi.first <= 0 && 0 <= prvi.second && prvi.first <= prvi.second)
            {
                pair <char, ll> par;
                par = {'*', M[i]};
                pair<pair<ll, ll>, vector<pair<char, ll> > > sad = {{prvi.first, prvi.second}, {par}};
                svi_intervali.push_back(sad);
            }
            else
            {
                if(prvi.first <= prvi.second)
                {
                    pair <char, ll> par;
                    par = {'*', M[i]};
                    pair<pair<ll, ll>, vector<pair<char, ll> > > sad = {{prvi.first, prvi.second}, {par}};
                    svi_intervali.push_back(sad);
                }
            }
        }
        else
        {
            set <pair<pair<ll, ll>, vector<pair<char, ll> > >> novi;
            for(int j = 0; j < (int) svi_intervali.size(); j++)
            {
                vector <pair<char, ll> > sad = svi_intervali[j].second;
                ll levo = svi_intervali[j].first.first;
                ll desno = svi_intervali[j].first.second;

                pair <ll, ll> prvi;
                if(M[i] == 0) prvi = {L[i], R[i]};
                else prvi = {levo / M[i], desno / M[i]};
                if(prvi.first > prvi.second) swap(prvi.first, prvi.second);

                pair <ll, ll> drugi = {levo - A[i], desno - A[i]};
                if(drugi.first > drugi.second) swap(drugi.first, drugi.second);

                prvi.first = max(prvi.first, L[i - 1]);
                prvi.second = min(prvi.second, R[i - 1]);

                drugi.first = max(drugi.first, L[i - 1]);
                drugi.second = min(drugi.second, R[i - 1]);

                vector <pair<char, ll> > op1 = sad, op2 = sad;
                op1.push_back({'*', M[i]});
                op2.push_back({'+', A[i]});

                if(drugi.first <= drugi.second)
                        novi.insert({{drugi.first, drugi.second}, op2});
                if(M[i] == 0 && prvi.first <= 0 && 0 <= prvi.second)
                    novi.insert({{prvi.first, prvi.second}, op1});
                else if(prvi.first <= prvi.second)
                    novi.insert({{prvi.first, prvi.second}, op1});

            }
            svi_intervali.clear();
            for(auto in : novi) svi_intervali.push_back(in);
        }
    }
}

bool saberi(ll X, ll Y)
{
    if ((Y > 0 && X > LLONG_MAX - Y) || (Y < 0 && X < LLONG_MIN - Y)) return false;
    return true;
}

bool pomnozi(ll X, ll Y)
{
    if(X == 0 || Y == 0) return true;
    ll rez = X*Y;
    if(X > 0 && Y > 0 && rez < 0) return false;
    if(X < 0 && Y < 0 && rez < 0) return false;
    if(X > 0 && Y < 0 && rez > 0) return false;
    if(X < 0 && Y > 0 && rez > 0) return false;
    return true;
}

ll Jednacina(ll X, vector <pair <char, ll> > operacije)
{
    ll rez = X;
    for(int i = (int) operacije.size() - 1; i >= 0; i--)
    {
        char znak = operacije[i].first;
        ll broj = operacije[i].second;
        if(znak == '*')
        {
            if(pomnozi(rez, broj)) rez *= broj;
            else return -2e18;
        }
        else
        {
            if(saberi(rez, broj)) rez += broj;
            else return -2e18;
        }
    }
    return rez;
}

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    ll T, N, S;
    cin >> T;
    while(T--)
    {
        cin >> N >> S;
        vector <ll> A(N), M(N), L(N), R(N);
        for(int i = 0; i < N; i++) cin >> M[i];
        for(int i = 0; i < N; i++) cin >> A[i];
        for(int i = 0; i < N; i++) cin >> L[i];
        for(int i = 0; i < N; i++) cin >> R[i];
        ll maks = -2e18;
        vector <ll> prvih_pola;
        vector <pair<pair<ll, ll>, vector<pair<char, ll> > > > svi_intervali;
        if(N%2)
        {
            Solve(N/2 + 1, S, A, M, L, R, prvih_pola);
            Intervali(N/2 + 1, N, A, M, L, R, svi_intervali);
        }
        else
        {
            Solve(N/2, S, A, M, L, R, prvih_pola);
            Intervali(N/2, N, A, M, L, R, svi_intervali);
        }
        for(auto trenutni_interval : svi_intervali)
        {
            ll l = trenutni_interval.first.first;
            ll r = trenutni_interval.first.second;
            vector <pair<char, ll> > oper = trenutni_interval.second;
            ll idx1 = lower_bound(prvih_pola.begin(), prvih_pola.end(), l) - prvih_pola.begin();
            ll idx2 = upper_bound(prvih_pola.begin(), prvih_pola.end(), r) - prvih_pola.begin() - 1;
            if(idx1 >= 0 && idx1 < (int) prvih_pola.size())
            {
                ll X = prvih_pola[idx1];
                ll resenje = Jednacina(X, oper);
                maks = max(maks, resenje);
            }
            if(!(idx2 >= 0 && idx2 < (int) prvih_pola.size())) idx2 = 0;
            ll Y = prvih_pola[idx2];
            ll resenje = Jednacina(Y, oper);
            maks = max(maks, resenje);
        }
        if(maks == -2e18) cout << "nemoguce" << endl;
        else cout << maks << endl;
    }
    return 0;
}