#include <iostream>
#include <vector>
#include <deque>

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

    int n, m, s, t;
    cin >> n >> m >> s >> t;

    vector<vector<int>> a(n);
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        x--; y--;
        a[x].push_back(y);
        a[y].push_back(x);
    }

    s--; t--;

    deque<int> dq;
    dq.push_back(s);
    vector<int> distance(n, -1);
    distance[s] = 0;
    vector<int> parent(n, -1);

    while (!dq.empty()) {
        int x = dq.front();
        dq.pop_front();
        

        for (int i : a[x]) {
            if ((i == x) && (distance[i] == -1 || distance[i] > distance[x])) {
                dq.push_front(i);
                distance[i] = distance[x];
                parent[i] = x;
            } else if ((i != x) && (distance[i] == -1 || distance[i] > (distance[x] + 1))) {
                dq.push_back(i);
                distance[i] = distance[x] + 1;
                parent[i] = x;
            }
        }
    }

    if (distance[t] % 2 != 0)
        distance[t] = distance[t] / 2 + 1;
    else
        distance[t] /= 2;

    cout << distance[t] << endl;
}