#include <bits/stdc++.h>
#define MAXN 150010

using namespace std;

typedef long long ll;

ll n, k;
pair<ll, ll> a[MAXN];
pair<ll, ll> b[MAXN];
ll c[MAXN];
ll fs[MAXN];
ll temp[MAXN];
vector<tuple<ll, ll, ll, ll>> v;

ll ZbirPrefiksa(ll k)
{
    ll zbir = 0;
    while (k > 0)
    {
        zbir += fs[k];
        k -= k & -k;
    }
    return zbir;
}

void Dodaj(ll k, ll x)
{
    while (k <= n)
    {
        fs[k] += x;
        k += k & -k;
    }
}

void Poredak()
{
	for(ll i = 1; i <= n; i++) temp[i] = c[i];
	sort(temp + 1, temp + 1 + n);
	for(ll i = 1; i <= n; i++)
	{
		c[i] = lower_bound(temp + 1, temp + 1 + n, c[i]) - temp;
	}
}

int BrInverzija()
{
	ll br = 0;
	Poredak();
	for(ll i = 1; i <= n; i++) fs[i] = 0;
	for(ll i = n; i >= 1; i--)
	{
		br += ZbirPrefiksa(c[i] - 1);
		Dodaj(c[i], 1);
	}
	return br;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cin >> n >> k;
    for(int i = 1; i <= n; i++)
    {
        cin >> a[i].first >> a[i].second;
        a[i].first *= 100000;
    }
    if(n == 2)
    {
        cout << fixed << showpoint << setprecision(10) << -(double)(a[2].first - a[1].first) / (a[2].second - a[1].second) / 100000.0;
        return 0;
    }
    else if(k == 1)
    {
        ll mini = LLONG_MAX;
        for(int i = 1; i < n; i++)
        {
            if(a[i].second != a[i + 1].second)
            {
                c[i] = -(a[i + 1].first - a[i].first) / (a[i + 1].second - a[i].second);
                if(c[i] > 0) mini = min(c[i], mini);
            }
        }
        cout << (double)mini / 100000.0;
        return 0;
    }
    else if(k <= 300000)
    {
        ll cnt = 0;
        for(int i = 1; i < n; i++)
        {
            if(a[i].second != a[i + 1].second)
            {
                v.push_back(make_tuple((a[i + 1].first - a[i].first) / (a[i + 1].second - a[i].second), i, a[i].first, a[i + 1].first));
            }
        }
        make_heap(v.begin(), v.end());
        ll rez = 0;
        while(cnt != k)
        {
            while(get<0>(v.front()) > 0)
            {
                pop_heap(v.begin(), v.end());
                v.pop_back();
            }
            tuple<ll, ll, ll, ll> t = v.front();
            rez = get<0>(v.front());
            pop_heap(v.begin(), v.end());
            v.pop_back();
            cnt++;
            ll i = get<1>(t);
            swap(a[i], a[i + 1]);
            v.push_back(make_tuple((a[i + 1].first - a[i + 2].first) / (a[i + 1].second - a[i + 2].second), i + 1, min(a[i + 1].first, a[i + 2].first), max(a[i + 1].first, a[i + 2].first)));
            push_heap(v.begin(), v.end());
            v.push_back(make_tuple((a[i - 1].first - a[i].first) / (a[i - 1].second - a[i].second), i - 1, min(a[i - 1].first, a[i].first), max(a[i - 1].first, a[i].first)));
            push_heap(v.begin(), v.end());
            while(v.front() == t)
            {
                pop_heap(v.begin(), v.end());
                v.pop_back();
            }
        }
        cout << -(double)rez / 100000.0;
        return 0;
    }
    ll l = 0, r = 100000000000000LL;
    ll mid, prevmid = -1;
    for(int i = 1; i <= n; i++)
    {
        c[i] = a[i].second;
    }
    ll inverzije = BrInverzija();
    while(l <= r)
    {
        mid = (l + r + 1) / 2;
        for(int i = 1; i <= n; i++)
        {
            b[i].first = a[i].first + a[i].second * mid;
            b[i].second = a[i].second;
        }
        sort(b + 1, b + 1 + n);
        for(int i = 1; i <= n; i++) c[i] = b[i].second;
        ll inv = inverzije - BrInverzija();
        if(inv < k)
        {
            l = mid;
        }
        else
        {
            r = mid;
        }
        if(mid == prevmid) break;
        prevmid = mid;
    }
    cout << (double)mid / 100000.0;
    return 0;
}