#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

#include <bits/stdc++.h>

#define ll long long
#define MAX_N 150000
#define MAX_RES 1000000001

using namespace::std;

int n;
ll k;
int x[MAX_N], v[MAX_N], temp[MAX_N];
pair<double, int> g[MAX_N];

bool brute_force2()
{
    if(k != 1) return false;
    double mint = INFINITY, t;

    for(int i=1;i<n;i++) {
        if(v[i-1] <= v[i]) continue;
            t = (double)(x[i] - x[i-1]) / (v[i-1] - v[i]);

        mint = min(t, mint);
    }

    cout << fixed << setprecision(9) << mint << endl;
    return true;
}

ll merge(pair<double, int> g[], int temp[], int l, int m, int r)
{
    int i, j, k;
    ll ic = 0;
 
    i = l;
    j = m;
    k = l;
    while ((i <= m - 1) && (j <= r)) {
        if (g[i].second <= g[j].second)
            temp[k++] = g[i++].second;
        else {
            temp[k++] = g[j++].second;
            ic += (m - i);
        }
    }
    while (i <= m - 1)
        temp[k++] = g[i++].second;
    while (j <= r)
        temp[k++] = g[j++].second;
    for (i = l; i <= r; i++)
        g[i].second = temp[i];
    return ic;
}

ll merge_sort(pair<double, int> g[], int temp[], int l, int r)
{
    int m;
    ll ic = 0;
    if (r > l) {
        m = (r + l) / 2;
        ic += merge_sort(g, temp, l, m);
        ic += merge_sort(g, temp, m + 1, r);
        ic += merge(g, temp, l, m + 1, r);
    }
    return ic;
}

bool main_solution()
{
    double l = 0, r = MAX_RES, m = 0;
    ll invs;
    while(abs(r - l) > 0.00001)
    {
        m = (l + r) / 2;
        for(int i=0;i<n;i++) {
            g[i].second = i;
            g[i].first = m * v[i] + x[i];
        }
        sort(g, g+n);
        invs = merge_sort(g, temp, 0, n);
        if(invs >= k) r = m;
        else l = m;
    }
    cout << fixed << setprecision(9) << m << endl;
    return true;
}

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    cin >> n >> k;
    for(int i=0;i<n;i++) cin >> x[i] >> v[i];
    brute_force2() || main_solution();
}