#include <iostream>
#include <set>
#include <queue>

struct podaci_o_stanici {
    std::set<int> povezane_stanice;
};

int main() {
    int n, m;
    int s, t;
    int i, j;
    int a, b;
    int rez;

    std::cin >> n;
    std::cin >> m;
    std::cin >> s;
    std::cin >> t;
    podaci_o_stanici *linije = new podaci_o_stanici[n];

    s--;
    t--;

    for (i=0; i<m; i++) {
        std::cin >> a;
        std::cin >> b;

        a--;
        b--;

        linije[a].povezane_stanice.insert(b);
        linije[b].povezane_stanice.insert(a);
    }
    
    int trenutno;
    int razdaljina;
    std::set<int> posecene;
    std::queue<std::pair<int, int>> q;
    q.push({s, 0});

    while (!q.empty()) {
        trenutno = q.front().first;
        razdaljina = q.front().second;
        q.pop();
        
        if (trenutno==t) {
            break;
        }

        if (posecene.find(trenutno)==posecene.end()) {
            posecene.insert(trenutno);
            
            for (const auto& stanica_i : linije[trenutno].povezane_stanice) {
                for (const auto& stanica_j : linije[stanica_i].povezane_stanice) {
                    if (linije[stanica_i].povezane_stanice.find(stanica_j)!=linije[trenutno].povezane_stanice.end()) {
                        q.push({stanica_j, razdaljina+1});
                        posecene.insert(trenutno);
                    }
                }
            }
        }
    }

    std::cout<<razdaljina;

    delete[] linije;

    return 0;
}