#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <queue>
#include <list>
#include <set>
#include <iomanip>
using namespace std;
typedef long long ll;
void tri_tajna_broja() {
	vector<ll> vrednosti(7);
	for (int i = 0; i < 7; i++)
		cin >> vrednosti[i];
	sort(vrednosti.begin(), vrednosti.end());
	vector<ll> elementi(3);
	elementi[0] = vrednosti[6] - vrednosti[5];
	elementi[1] = vrednosti[6] - vrednosti[4];
	elementi[2] = vrednosti[6] - elementi[0] - elementi[1];
	sort(elementi.begin(), elementi.end());
	for (auto el : elementi)
		cout << el << " ";

}
void veca_trka() {
	int n, k;
	cin >> n >> k;
	vector<pair<int, int>>trka(n);
	for (int i = 0; i < n; i++)
	{
		int poz, brzina;
		cin >> poz >> brzina;
		trka[i] = { poz, brzina };
	}
	sort(trka.begin(), trka.end());
	priority_queue<double, vector<double>, greater<double>>q;
	for (int i = 0; i < n - 1; i++)
	{
		for (int j = i + 1; j < n; j++)
		{
			if (trka[j].second >= trka[i].second)
				continue;
			q.push(double(double(trka[j].first - trka[i].first) / double(trka[i].second - trka[j].second)));
		}
	}
	while (--k)
		q.pop();
	cout << fixed << setprecision(9) << q.top();

}
void moramo_da_recikliramo() {
	int n;
	cin >> n;
	vector<ll>broj_zalbi(n);
	vector<ll>kapacitet(n);
	for (int i = 0; i < n; i++)
		cin >> broj_zalbi[i];
	for (int i = 0; i < n; i++)
		cin >> kapacitet[i];
	int Q;
	cin >> Q;
	while (Q--)
	{
		int clan;
		ll zalbe;
		cin >> clan >> zalbe;
		clan--;
		while (zalbe > 0 && clan < n) {
			if (kapacitet[clan] - broj_zalbi[clan] >= zalbe) {
				broj_zalbi[clan] += zalbe;
				zalbe = 0;
			}
			else if(kapacitet[clan] - broj_zalbi[clan] > 0) {
				zalbe -= kapacitet[clan] - broj_zalbi[clan];
				broj_zalbi[clan] = kapacitet[clan];
			}
			clan++;
		}
	}
	for (const auto& el : broj_zalbi)
		cout << el << " ";

}
void fejk_reklama() {
	int T;
	cin >> T;
	while (T--)
	{
		ll n, broj_vojnika;
		cin >> n >> broj_vojnika;
		vector<ll>m(n), a(n), l(n), r(n);
		for (int i = 0; i < n; i++) cin >> m[i];
		for (int i = 0; i < n; i++) cin >> a[i];
		for (int i = 0; i < n; i++) cin >> l[i];
		for (int i = 0; i < n; i++) cin >> r[i];

		bool moguce = true;
		int i = 0;
		while (moguce && i < n)
		{
			ll umnozak = LLONG_MIN, zbir = LLONG_MIN;
			if ((broj_vojnika * m[i] < l[i] || broj_vojnika * m[i] > r[i]) &&
				(broj_vojnika + a[i] < l[i] || broj_vojnika + a[i] > r[i]))
				moguce = false;

			if (broj_vojnika * m[i] >= l[i] && broj_vojnika * m[i] <= r[i])
				umnozak = broj_vojnika * m[i];
			if (broj_vojnika + a[i] >= l[i] && broj_vojnika + a[i] <= r[i])
				zbir = broj_vojnika + a[i];
			else moguce = false;
			broj_vojnika = max(umnozak, zbir);
			i++;
		}
		if (moguce)
			cout << broj_vojnika << endl;
		else
			cout << "nemoguce" << endl;
	}
}
void presedanja() {
	int n, m, s, t;
	cin >> n >> m >> s >> t;
	vector<set<int>> graf(n + 1);
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		graf[a].insert(b);
		graf[b].insert(a);
	}
	vector<set<int>> novi_graf(graf);
	for (int cvor = 1; cvor <= n; cvor++)
	{
		for (auto sused1 : graf[cvor]) {
			for (auto sused2 : graf[cvor]) {
				if (sused1 == sused2) continue;
				novi_graf[sused1].insert(sused2);
			}
		}
	}
	priority_queue<pair<int, int>, vector<pair<int, int>>, greater<pair<int, int>>>q;
	vector<bool> resen(n + 1, false);
	vector<int> duzinaPuta(n + 1, INT_MAX);
	q.emplace(0, s);
	while (!q.empty())
	{
		int minCvor, minDuzina;
		tie(minDuzina, minCvor) = q.top(); q.pop();
		if (resen[minCvor]) continue;
		resen[minCvor] = true;
		for (auto sused : novi_graf[minCvor]) {
			if (!resen[sused] && minDuzina + 1 < duzinaPuta[sused]) {
				duzinaPuta[sused] = minDuzina + 1;
				q.emplace(duzinaPuta[sused], sused);

			}
		}
	}
	if (duzinaPuta[t] < INT_MAX) {
		cout << duzinaPuta[t];
	}
}
int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	moramo_da_recikliramo();
}