#define _CRT_DISABLE_PERFCRIT_LOCKS
#define _CRT_SECURE_NO_WARNINGS
#define FASTIO ios_base::sync_with_stdio(false); cin.tie(NULL)
#define ll long long
#define vcip vector<pair<int, int>>

#include <iostream>
#include <vector>
#include <map>
#include <list>
#include <algorithm>
#include <string>
using namespace std;

vector<int> resenja;

int partition(vector<int>& arr, int start, int end)
{

    int pivot = arr[start];

    int count = 0;
    for (int i = start + 1; i <= end; i++) {
        if (arr[i] <= pivot)
            count++;
    }

    int pivotIndex = start + count;
    swap(arr[pivotIndex], arr[start]);

    int i = start, j = end;

    while (i < pivotIndex && j > pivotIndex) {

        while (arr[i] <= pivot) {
            i++;
        }

        while (arr[j] > pivot) {
            j--;
        }

        if (i < pivotIndex && j > pivotIndex) {
            swap(arr[i++], arr[j--]);
        }
    }

    return pivotIndex;
}

void quickSort(vector<int>& arr, int start, int end)
{
    if (start >= end)
        return;
    int p = partition(arr, start, end);
    quickSort(arr, start, p - 1);
    quickSort(arr, p + 1, end);
}


void traverse(vcip prepreke, vcip granice, int index, int vojska)
{
    if (index == prepreke.size() - 1)
    {
        if (!(vojska * prepreke[index].first > granice[index].second || vojska * prepreke[index].first < granice[index].first))
        {
            resenja.push_back(vojska * prepreke[index].first);
        }
        if (!(vojska + prepreke[index].second > granice[index].second || vojska + prepreke[index].second < granice[index].first))
        {
            resenja.push_back(vojska + prepreke[index].second);
        }
    }
    else
    {
        if (!(vojska * prepreke[index].first > granice[index].second || vojska * prepreke[index].first < granice[index].first))
        {
            traverse(prepreke, granice, index + 1, vojska * prepreke[index].first);
        }
        if (!(vojska + prepreke[index].second > granice[index].second || vojska + prepreke[index].second < granice[index].first))
        {
            traverse(prepreke, granice, index + 1, vojska + prepreke[index].second);
        }
    }
}

int main()
{
    FASTIO;
    int brojnivoa;
    scanf("%d", &brojnivoa);
    vector<string> glavnaresenja;

    for (int z = 0; z < brojnivoa; z++)
    {
        int brojprepreka, vojska;
        vcip prepreke;
        vcip granice;
        scanf("%d %d", &brojprepreka, &vojska);
        for (int i = 0; i < brojprepreka; i++)
        {
            pair<int, int> temp;
            temp.second = 0;
            scanf("%d", &temp.first);
            prepreke.push_back(temp);
        }

        for (int i = 0; i < brojprepreka; i++)
        {
            scanf("%d", &prepreke[i].second);
        }

        for (int i = 0; i < brojprepreka; i++)
        {
            pair<int, int> temp;
            temp.second = 0;
            scanf("%d", &temp.first);
            granice.push_back(temp);
        }

        for (int i = 0; i < brojprepreka; i++)
        {
            scanf("%d", &granice[i].second);
        }

        traverse(prepreke, granice, 0, vojska);

        if (resenja.size() == 0) glavnaresenja.push_back("nemoguce");
        else
        {
            quickSort(resenja, 0, resenja.size() - 1);
            glavnaresenja.push_back(to_string(resenja[resenja.size() - 1]));
        }
        resenja.clear();
    }

    for (int i = 0; i < brojnivoa; i++)
    {
        printf("%s \n", glavnaresenja[i].c_str());
    }
}