using System;
using System.Collections.Generic;

namespace presedanja
{
    internal class Program
    {
        static int najkraciPut(List<List<int>> lista, int s, int t)
        {
            int n = lista.Count;
            int[] put = new int[n];
            bool[] poseceno = new bool[n];
            for (int i = 0; i < n; i++)
            {
                put[i] = int.MaxValue;
                poseceno[i] = false;
            }
            put[s] = 0;
            for (int i = 0; i < n-1; i++)
            {
                int a = minimumPuteva(put, poseceno);
                poseceno[a] = true;
            }
            return put[t];
        }
        static int minimumPuteva(int[] put, bool[] poseceno)
        {
            int min = int.MaxValue;
            int br = 0;
            int n = put.Length;
            for (int i = 0; i < n; i++)
            {
                if (!poseceno[i] && put[i] <= min)
                {
                    min = put[i];
                    br = i-1;
                }
            }
            return br;
        }
        static void Main(string[] args)
        {
            string[] ulaz1 = Console.ReadLine().Split();
            int n = int.Parse(ulaz1[0]);
            int m = int.Parse(ulaz1[1]);    
            int s = int.Parse(ulaz1[2]);
            int t = int.Parse(ulaz1[3]);
            List<List<int>> lista = new List<List<int>>();
            for(int i = 0; i < n; i++)
                lista.Add(new List<int>());
            for(int i = 0; i < m; i++)
            {
                string[] ulaz2 = Console.ReadLine().Split();
                int u = int.Parse(ulaz2[0]);
                int v = int.Parse(ulaz2[1]);
                lista[u].Add(v);
                lista[v].Add(u);
            }
            int minimalanBrojAutobusa = najkraciPut(lista,s,t);
            Console.WriteLine(minimalanBrojAutobusa);
        }
    }
}