using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleApplication1
{
    class Program
    {
        static void pravljenje_matrice_povezanostiDvos(int[,] A, int m)//pravljenje dvosmerne matrice
        {
            int a, b;
            string probni;
            string[] pr;
            int c = m;
            while (c != 0)
            {
                probni = Console.ReadLine();
                pr = probni.Split(' ');
                a = int.Parse(pr[0]);
                b = int.Parse(pr[1]);
                A[a - 1, b - 1] = 1;//Brojevi se pretvaraju u kompijutersko citljive brojeve
                A[b - 1, a - 1] = 1;
                c--;
            }
        }
        static int[,] matrica_create(int n)//kreiranje matrice
        {
            int[,] A = new int[n, n];
            for (int p = 0; p < n; p++)
            {
                for (int q = 0; q < n; q++)
                {
                    A[p, q] = 0;
                }
            }
            return A;
        }
        //
        //
        //BITNA FUNKCIJA (i podfunkcije)
        static void nove_rute(int[,] A, int N) //Glavna funkcija
        {
            List<int[]> noverute = new List<int[]>();
            for (int p = 0; p < N; p++)
            {
                List<int> kandidati = sum_red(A, p, N);
                if (kandidati.Count < 2) { continue; }
                else if (kandidati.Count == 2) { noverute.Add(new int[] { kandidati[0], kandidati[1] }); }
                else { belezi(A, N, kandidati, noverute); }
            }
            foreach (int[] E in noverute)
            {
                dodaj_putDVOS(A, E[0], E[1]);
            }
        }
        static void belezi(int[,] A, int N, List<int> kandidati, List<int[]> putevi)//Koristi se SAMO ako ima viže od 2 opcije u redu (više od dve "crte" poticu od "tacke")
        {
            int duzina = kandidati.Count;
            for (int p = 0; p < duzina - 1; p++)
            {
                for (int q = p + 1; q < duzina; q++)
                {
                    if (!putevi.Contains(new int[] { kandidati[p], kandidati[q] }))
                    {
                        putevi.Add(new int[] { kandidati[p], kandidati[q] });
                    }
                }
            }
        }
        static void dodaj_putDVOS(int[,] A, int S, int T)//klasicna func dodavanja novih puteva
        {
            A[S, T] = 1;
            A[T, S] = 1;
        }
        static List<int> sum_red(int[,] A, int p, int N)//pravi "kandidate" i kasnije se to koristi za spajanje
        {
            List<int> kandidati = new List<int>();
            for (int q = 0; q < N; q++)
            {
                if (A[p, q] == 1) { kandidati.Add(q); }
            }
            return kandidati;
        }
        //BITNA FUNKCIJA (i podfunkcije)
        //
        //
        static void najbrži_put(int polazniCvor, int zavrsniCvor, int[,] A, int N)
        {
            if (polazniCvor == zavrsniCvor) { Console.WriteLine("0"); return; }
            int c = 1;
            var zaPosetu = new Stack<int>();
            var trenutni = new Stack<int>();
            trenutni.Push(polazniCvor);
            while (trenutni.Count > 0)
            {
                int tekuciCvor = trenutni.Pop();
                for (int l = 0; l < N; l++)
                {
                    if (A[tekuciCvor, l] == 1)
                    {
                        if (l == zavrsniCvor) { Console.WriteLine(c); return; }
                        zaPosetu.Push(l);
                    }
                }
                if (trenutni.Count == 0) { trenutni = zaPosetu; zaPosetu = new Stack<int>(); c += 1; }
            }
        }
        static void Main(string[] args)
        {
            string[] NMST = Console.ReadLine().Split(' ');
            int N = int.Parse(NMST[0]); int M = int.Parse(NMST[1]); int S = int.Parse(NMST[2]); int T = int.Parse(NMST[3]);
            int[,] A = matrica_create(N);
            pravljenje_matrice_povezanostiDvos(A, M);
            nove_rute(A, N);
            najbrži_put(S - 1, T - 1, A, N);
        }
    }
}