#include <bits/stdc++.h>

using namespace std;

#define ll long long
const int INF=1e9;
const ll LINF=1e18;
#define fi first
#define se second
#define pii pair<int,int>
#define pll pair<long long,long long>
#define mid ((l+r)/2)
#define sz(a) (int((a).size()))
#define all(a) a.begin(),a.end()
#define endl "\n"
#define pb push_back

void PRINT(int x) {cerr << x;}
void PRINT(ll x) {cerr << x;}
void PRINT(double x) {cerr << x;}
void PRINT(char x) {cerr << '\'' << x << '\'';}
void PRINT(string x) {cerr << '\"' << x << '\"';}
void PRINT(bool x) {cerr << (x ? "true" : "false");}

template<typename T,typename V>
void PRINT(pair<T,V>& x){
    cerr<<"{";
    PRINT(x.fi);
    cerr<<",";
    PRINT(x.se);
    cerr<<"}";
}
template<typename T>
void PRINT(T &x){
    int id=0;
    cerr<<"{";
    for(auto _i:x){
        cerr<<(id++ ? "," : "");
        PRINT(_i);
    }
    cerr<<"}";
}
void _PRINT(){
    cerr<<"]\n";
}
template<typename Head,typename... Tail>
void _PRINT(Head h,Tail... t){
    PRINT(h);
    if(sizeof...(t)) cerr<<", ";
    _PRINT(t...);
}

#define Debug(x...) cerr<<"["<<#x<<"]=["; _PRINT(x)

ll N,S;
ll A[41],M[41],L[41],R[41];

vector<pll> functions,segs;
set<ll> xs;

void FindXs(int i,ll x){
    if(i==N/2+1){
        xs.insert(x);
        return;
    }
    if(L[i]<=x*M[i] && x*M[i]<=R[i]) FindXs(i+1,x*M[i]);
    if(L[i]<=x+A[i] && x+A[i]<=R[i]) FindXs(i+1,x+A[i]);
}

pll Intersect(pll& i1,pll& i2){
    return {max(i1.fi,i2.fi),min(i1.se,i2.se)};
}

ll Floor(ll a,ll b){
    if(a%b) return a/b;
    return a/b-((a<0)^(b<0));
}

ll Ceil(ll a,ll b){
    if(a%b) return a/b;
    return a/b+(!((a<0)^(b<0)));
}

void FindFunc(int i,pll func,pll s){
    if(i==N+1){
        functions.pb(func);
        segs.pb(s);
        return;
    }
    pll nfunc={func.fi*M[i],func.se*M[i]};
    pll ns,s1;
    if(nfunc.fi==0){
        if(L[i]<=nfunc.se && nfunc.se<=R[i]) FindFunc(i+1,nfunc,s);
    }
    else if(nfunc.fi>0){
        s1.fi=Ceil(L[i]-nfunc.se,nfunc.fi);
        s1.se=Floor(R[i]-nfunc.se,nfunc.fi);
        if(s1.fi<=s1.se){
            ns=Intersect(s,s1);
            if(ns.fi<=ns.se) FindFunc(i+1,nfunc,ns);
        }
    }
    else{
        s1.fi=Ceil(R[i]-nfunc.se,nfunc.fi);
        s1.se=Floor(L[i]-nfunc.se,nfunc.fi);
        if(s1.fi<=s1.se){
            ns=Intersect(s,s1);
            if(ns.fi<=ns.se) FindFunc(i+1,nfunc,ns);
        }
    }
    nfunc={func.fi,func.se+A[i]};
    if(nfunc.fi==0){
        if(L[i]<=nfunc.se &&  nfunc.se<=R[i]) FindFunc(i+1,nfunc,s);
    }
    else if(nfunc.fi>0){
        s1.fi=Ceil(L[i]-nfunc.se,nfunc.fi);
        s1.se=Floor(R[i]-nfunc.se,nfunc.fi);
        if(s1.fi<=s1.se){
            ns=Intersect(s,s1);
            if(ns.fi<=ns.se) FindFunc(i+1,nfunc,ns);
        }
    }
    else{
        s1.fi=Ceil(R[i]-nfunc.se,nfunc.fi);
        s1.se=Floor(L[i]-nfunc.se,nfunc.fi);
        if(s1.fi<=s1.se){
            ns=Intersect(s,s1);
            if(ns.fi<=ns.se) FindFunc(i+1,nfunc,ns);
        }
    }
}

void Solve(){
    cin>>N>>S;
    xs.clear(); functions.clear(); segs.clear();
    for(int i=1;i<=N;i++) cin>>M[i];
    for(int i=1;i<=N;i++) cin>>A[i];
    for(int i=1;i<=N;i++) cin>>L[i];
    for(int i=1;i<=N;i++) cin>>R[i];
    L[0]=-INF; R[0]=INF;
    if(N!=1) FindXs(1,S);
    else xs.insert(S);
    FindFunc(N/2+1,{1,0},{L[N/2],R[N/2]});
    ll res=-INF-1;
    for(int i=0;i<sz(functions);i++){
        ll m=functions[i].fi,a=functions[i].se;
        ll l=segs[i].fi,r=segs[i].se;
        if(m>0){
            auto ub=xs.upper_bound(r);
            if(ub!=xs.begin() && (*prev(ub))>=l){
                res=max(res,m*(*prev(ub))+a);
            }
        }
        else if(m<0){
            auto lb=xs.lower_bound(l);
            if(lb!=xs.end() && (*lb)<=r){
                res=max(res,m*(*lb)+a);
            }
        }
        else{
            auto lb=xs.lower_bound(l);
            if(lb!=xs.end() && (*lb)<=r){
                res=max(res,a);
            }
        }
    }
    cout<<(res!=(-INF-1) ? to_string(res) : "nemoguce")<<endl;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin>>t;
    //t=1;
    while(t--){
        Solve();
    }
    return 0;
}