#include <bits/stdc++.h>
 
using namespace std;

const long double eps = 1e-8;

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n;
  cin >> n;
  long long k;
  cin >> k;
  vector<int> x(n), v(n);
  for (int i = 0; i < n; i++) {
    cin >> x[i] >> v[i];
  }
  vector<int> fenw(n + 1);
  auto Modify = [&](int p, int v) {
    for (p += 1; p <= n; p += p & -p) {
      fenw[p] += v;
    }
  };
  auto Query = [&](int p) {
    int res = 0;
    for (p += 1; p; p -= p & -p) {
      res += fenw[p];
    }
    return res;
  };
  auto Check = [&](long double t) {
    vector<long double> pos(n);
    for (int i = 0; i < n; i++) {
      pos[i] = (long double) x[i] + t * (long double) v[i];
    }
    vector<int> order(n);
    iota(order.begin(), order.end(), 0);
    sort(order.begin(), order.end(), [&](int i, int j) {
      if (abs(pos[i] - pos[j]) < eps) {
        return i > j;
      } else {
        return pos[i] < pos[j];
      }
    });
    long long total = 0;
    for (int i = 1; i <= n; i++) {
      fenw[i] = 0;
    }
    for (int i = 0; i < n; i++) {
      total += i - Query(order[i]);
      Modify(order[i], +1);
    }
    return total >= k;
  };
  long double low = 0, high = 2e9, ans = 2e9;
  for (int iter = 0; iter < 80; iter++) {
    long double mid = (low + high) / 2;
    if (Check(mid)) {
      ans = mid;
      high = mid;
    } else {
      low = mid;
    }
  }
  cout << fixed << setprecision(6) << ans << '\n';
  return 0;
}